import { SvelteComponentTyped } from "svelte";

declare module 'js-hex-editor/NumberBase.ts' {
	export enum NumberBase {
	    Binary = 2,
	    Octal = 8,
	    Decimal = 10,
	    Hexadecimal = 16
	}
}

declare module 'js-hex-editor/utils.ts' {
	export function enumKeys<O extends object, K extends keyof O = keyof O>(obj: O): K[];
	export function ab2str(buf: ArrayBuffer): string;
	export function str2ab(str: string): ArrayBuffer;
	export function getBaseLog(x: number, y: number): number;
	export function numDigits(x: any, base?: number): number;
	export function iter_range(begin: any, end: any, step: any): Generator<any, void, unknown>;
	export function range(begin: any, end: any, step: any): any[];
}

declare module 'js-hex-editor' {
	export { default as HexEditor } from "./HexEditor.svelte";
	import { NumberBase as _NumberBase } from "./NumberBase";
	export const NumberBase: typeof _NumberBase;
	export interface HexEditorProps extends Partial<{
	    data: ArrayBuffer;
	    readonly: boolean;
	    showHeader: boolean;
	    showFooter: boolean;
	    height: string;
	    width: string;
	    offsetBase: _NumberBase;
	    dataBase: _NumberBase;
	    bytesPerLine: number;
	    start: number;
	    end: number;
	}> {
	}
}

declare module 'js-hex-editor/utils.ts' {
	export function enumKeys<O extends object, K extends keyof O = keyof O>(obj: O): K[];
	export function ab2str(buf: ArrayBuffer): string;
	export function str2ab(str: string): ArrayBuffer;
	export function getBaseLog(x: number, y: number): number;
	export function numDigits(x: any, base?: number): number;
	export function iter_range(begin: any, end: any, step: any): Generator<any, void, unknown>;
	export function range(begin: any, end: any, step: any): any[];
}

declare module 'js-hex-editor/NumberBase.ts' {
	export enum NumberBase {
	    Binary = 2,
	    Octal = 8,
	    Decimal = 10,
	    Hexadecimal = 16
	}
}

declare module 'js-hex-editor' {
	export { default as HexEditor } from "./HexEditor.svelte";
	import { NumberBase as _NumberBase } from "./NumberBase";
	export const NumberBase: typeof _NumberBase;
	export interface HexEditorProps extends Partial<{
	    data: ArrayBuffer;
	    readonly: boolean;
	    showHeader: boolean;
	    showFooter: boolean;
	    height: string;
	    width: string;
	    offsetBase: _NumberBase;
	    dataBase: _NumberBase;
	    bytesPerLine: number;
	    start: number;
	    end: number;
	}> {
	}
}

declare module 'js-hex-editor/HexEditor.svelte' {
	interface HexEditorProps {
		data: ArrayBuffer;
		readonly: boolean;
		showHeader: boolean;
		showFooter: boolean;
		height: string;
		width: string;
		offsetBase: NumberBase;
		dataBase: NumberBase;
		bytesPerLine: number;
		data: ArrayBuffer;
		readonly: boolean;
		showHeader: boolean;
		showFooter: boolean;
		height: string;
		width: string;
		offsetBase: NumberBase;
		dataBase: NumberBase;
		bytesPerLine: number;
		data: ArrayBuffer;
		readonly: boolean;
		showHeader: boolean;
		showFooter: boolean;
		height: string;
		width: string;
		offsetBase: NumberBase;
		dataBase: NumberBase;
		bytesPerLine: number;
	}

	export default class HexEditor extends SvelteComponentTyped<
		HexEditorProps,
		{  },
		{  }
	> {}
}

declare module 'js-hex-editor/Glyph.svelte' {
	interface GlyphProps {
		position: string;
		value: number;
		type: number;
		selected: boolean;
		maxItems: any;
		position: string;
		value: number;
		type: number;
		selected: boolean;
		maxItems: any;
		position: string;
		value: number;
		type: number;
		selected: boolean;
		maxItems: any;
	}

	export default class Glyph extends SvelteComponentTyped<
		GlyphProps,
		{  },
		{  }
	> {}
}

declare module 'js-hex-editor/Glyph.svelte' {
	interface GlyphProps {
		position: string;
		value: number;
		type: number;
		selected: boolean;
		maxItems: any;
		position: string;
		value: number;
		type: number;
		selected: boolean;
		maxItems: any;
		position: string;
		value: number;
		type: number;
		selected: boolean;
		maxItems: any;
	}

	export default class Glyph extends SvelteComponentTyped<
		GlyphProps,
		{  },
		{  }
	> {}
}

declare module 'js-hex-editor/HexEditor.svelte' {
	interface HexEditorProps {
		data: ArrayBuffer;
		readonly: boolean;
		showHeader: boolean;
		showFooter: boolean;
		height: string;
		width: string;
		offsetBase: NumberBase;
		dataBase: NumberBase;
		bytesPerLine: number;
		data: ArrayBuffer;
		readonly: boolean;
		showHeader: boolean;
		showFooter: boolean;
		height: string;
		width: string;
		offsetBase: NumberBase;
		dataBase: NumberBase;
		bytesPerLine: number;
		data: ArrayBuffer;
		readonly: boolean;
		showHeader: boolean;
		showFooter: boolean;
		height: string;
		width: string;
		offsetBase: NumberBase;
		dataBase: NumberBase;
		bytesPerLine: number;
	}

	export default class HexEditor extends SvelteComponentTyped<
		HexEditorProps,
		{  },
		{  }
	> {}
}

declare module 'js-hex-editor/HexEditor.svelte' {
	interface HexEditorProps {
		data: ArrayBuffer;
		readonly: boolean;
		showHeader: boolean;
		showFooter: boolean;
		height: string;
		width: string;
		offsetBase: NumberBase;
		dataBase: NumberBase;
		bytesPerLine: number;
	}

	export default class HexEditor extends SvelteComponentTyped<
		HexEditorProps,
		{  },
		{  }
	> {}
}

declare module 'js-hex-editor/Glyph.svelte' {
	interface GlyphProps {
		position: string;
		value: number;
		type: number;
		selected: boolean;
		maxItems: any;
	}

	export default class Glyph extends SvelteComponentTyped<
		GlyphProps,
		{  },
		{  }
	> {}
}

declare module 'js-hex-editor' {
	export { default as HexEditor } from "./HexEditor.svelte";
	import { NumberBase as _NumberBase } from "./NumberBase";
	export const NumberBase: typeof _NumberBase;
	export interface HexEditorProps extends Partial<{
	    data: ArrayBuffer;
	    readonly: boolean;
	    showHeader: boolean;
	    showFooter: boolean;
	    height: string;
	    width: string;
	    offsetBase: _NumberBase;
	    dataBase: _NumberBase;
	    bytesPerLine: number;
	    start: number;
	    end: number;
	}> {
	}
}

declare module 'js-hex-editor/NumberBase.ts' {
	export enum NumberBase {
	    Binary = 2,
	    Octal = 8,
	    Decimal = 10,
	    Hexadecimal = 16
	}
}

declare module 'js-hex-editor/utils.ts' {
	export function enumKeys<O extends object, K extends keyof O = keyof O>(obj: O): K[];
	export function ab2str(buf: ArrayBuffer): string;
	export function str2ab(str: string): ArrayBuffer;
	export function getBaseLog(x: number, y: number): number;
	export function numDigits(x: any, base?: number): number;
	export function iter_range(begin: any, end: any, step: any): Generator<any, void, unknown>;
	export function range(begin: any, end: any, step: any): any[];
}

